/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return F}function t(){return x}function o(){return E}function a(e){E=e}function r(){return x.length-E}function s(){return x[E]}function i(){return x[E++]}function n(e){0===E?x.unshift(e):(E-=1,x[E]=e)}function l(){return(x[E++]<<8)+x[E++]}function u(){return(x[E++]<<24)+(x[E++]<<16)+(x[E++]<<8)+x[E++]}function d(e){"undefined"==typeof e&&(e=r());var t=x.slice(E,E+e);return E+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function c(e){return"undefined"==typeof e&&(e=r()),E+=e,x.slice(E-e,E)}function p(e,t){return t?x.slice(E+e,E+t):x.slice(E+e)}function h(e,t,o){var a=x.length-E;if(t>a){if(o){if(o>E)throw"rQwait cannot backup "+o+" bytes";E-=o}return!0}return!1}function m(){return Base64.encode(F)}function f(e){x=x.concat(Base64.decode(e,0))}function g(){return 0!==k.bufferedAmount&&Util.Debug("bufferedAmount: "+k.bufferedAmount),k.bufferedAmount<D.maxBufferedAmount?(F.length>0&&(k.send(m(F)),F=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+k.bufferedAmount),!1)}function v(e){return F=F.concat(e),g()}function b(e){D.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),r()>0?(L.message(),x.length>I&&(x=x.slice(E),E=0)):Util.Debug("Ignoring empty message")}catch(t){"undefined"!=typeof t.stack?Util.Warn("recv_message, caught exception: "+t.stack):"undefined"!=typeof t.description?Util.Warn("recv_message, caught exception: "+t.description):Util.Warn("recv_message, caught exception:"+t),"undefined"!=typeof t.name?L.error(t.name+": "+t.message):L.error(t)}}function w(e,t){L[e]=t}function A(){x=[],E=0,F=[],k=null}function S(e){A(),k=T?{}:new WebSocket(e,"base64"),k.onmessage=y,k.onopen=function(){Util.Debug(">> WebSock.onopen"),k.protocol&&Util.Info("Server chose sub-protocol: "+k.protocol),L.open(),Util.Debug("<< WebSock.onopen")},k.onclose=function(e){Util.Debug(">> WebSock.onclose"),L.close(e),Util.Debug("<< WebSock.onclose")},k.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),L.error(e),Util.Debug("<< WebSock.onerror")}}function C(){k&&((k.readyState===WebSocket.OPEN||k.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),k.close()),k.onmessage=function(e){})}function P(e){return T=!0,D.send=e,D.close=function(){},y}function _(){return D.maxBufferedAmount=200,D.get_sQ=e,D.get_rQ=t,D.get_rQi=o,D.set_rQi=a,D.rQlen=r,D.rQpeek8=s,D.rQshift8=i,D.rQunshift8=n,D.rQshift16=l,D.rQshift32=u,D.rQshiftStr=d,D.rQshiftBytes=c,D.rQslice=p,D.rQwait=h,D.flush=g,D.send=v,D.send_string=b,D.on=w,D.init=A,D.open=S,D.close=C,D.testMode=P,D}var D={},k=null,x=[],E=0,I=1e4,F=[],L={message:function(){},open:function(){},close:function(){},error:function(){}},T=!1;return _()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),o="'></script>",a="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),a+=t+"web-socket-js/swfobject.js"+o,a+=t+"web-socket-js/web_socket.js"+o,document.write(a)}());